C (c) CROWN COPYRIGHT 1995, METEOROLOGICAL OFFICE, All Rights Reserved.            RAD_ALL.24264 
C                                                                                  RAD_ALL.24265 
C Use, duplication or disclosure of this code is subject to the                    RAD_ALL.24266 
C restrictions as set forth in the contract.                                       RAD_ALL.24267 
C                                                                                  RAD_ALL.24268 
C                Meteorological Office                                             RAD_ALL.24269 
C                London Road                                                       RAD_ALL.24270 
C                BRACKNELL                                                         RAD_ALL.24271 
C                Berkshire UK                                                      RAD_ALL.24272 
C                RG12 2SZ                                                          RAD_ALL.24273 
C                                                                                  RAD_ALL.24274 
C If no contract has been raised with this copy of the code, the use,              RAD_ALL.24275 
C duplication or disclosure of it is strictly prohibited.  Permission              RAD_ALL.24276 
C to do so must first be obtained in writing from the Head of Numerical            RAD_ALL.24277 
C Modelling at the above address.                                                  RAD_ALL.24278 
C ******************************COPYRIGHT******************************            RAD_ALL.24279 
C                                                                                  RAD_ALL.24280 
!+ Subroutine to calculate coefficients in the two-stream equations.               RAD_ALL.24281 
!                                                                                  RAD_ALL.24282 
! Method:                                                                          RAD_ALL.24283 
!       The basic two-stream coefficients in the differential equations            RAD_ALL.24284 
!       are calculated. These are then used to determine the                       RAD_ALL.24285 
!       transmission and reflection coefficients. Coefficients for                 RAD_ALL.24286 
!       determining the solar or infra-red source terms are calculated.            RAD_ALL.24287 
!                                                                                  RAD_ALL.24288 
! Current Owner of Code: J. M. Edwards                                             RAD_ALL.24289 
!                                                                                  RAD_ALL.24290 
! History:                                                                         RAD_ALL.24291 
!       Version         Date                    Comment                            RAD_ALL.24292 
!       4.0             27-07-95                Original Code                      RAD_ALL.24293 
!                                               (J. M. Edwards)                    RAD_ALL.24294 
!       4.2             Nov. 96   T3E migration: CALL WHENFGT replaced             RAD_ALL.24295 
!                                  by portable fortran code.                       RAD_ALL.24296 
!                                                S.J.Swarbrick                     RAD_ALL.24297 
!                                                                                  RAD_ALL.24298 
! Description of Code:                                                             RAD_ALL.24299 
!   FORTRAN 77  with extensions listed in documentation.                           RAD_ALL.24300 
!                                                                                  RAD_ALL.24301 
!- ---------------------------------------------------------------------           RAD_ALL.24302 
      SUBROUTINE TWO_COEFF(IERR                                                    RAD_ALL.24303 
     &   , N_PROFILE, I_LAYER_FIRST, I_LAYER_LAST                                  RAD_ALL.24304 
     &   , I_2STREAM, L_IR_SOURCE_QUAD                                             RAD_ALL.24305 
     &   , ASYMMETRY, OMEGA, TAU                                                   RAD_ALL.24306 
     &   , ISOLIR, SEC_0                                                           RAD_ALL.24307 
     &   , TRANS, REFLECT, TRANS_0                                                 RAD_ALL.24308 
     &   , SOURCE_COEFF                                                            RAD_ALL.24309 
     &   , NPD_PROFILE, NPD_LAYER                                                  RAD_ALL.24310 
     &   )                                                                         RAD_ALL.24311 
!                                                                                  RAD_ALL.24312 
!                                                                                  RAD_ALL.24313 
!                                                                                  RAD_ALL.24314 
      IMPLICIT NONE                                                                RAD_ALL.24315 
!                                                                                  RAD_ALL.24316 
!                                                                                  RAD_ALL.24317 
!     SIZES OF DUMMY ARRAYS.                                                       RAD_ALL.24318 
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.24319 
     &     NPD_PROFILE                                                             RAD_ALL.24320 
!             MAXIMUM NUMBER OF PROFILES                                           RAD_ALL.24321 
     &   , NPD_LAYER                                                               RAD_ALL.24322 
!             MAXIMUM NUMBER OF LAYERS                                             RAD_ALL.24323 
!                                                                                  RAD_ALL.24324 
!     INCLUDE COMDECKS.                                                            RAD_ALL.24325 
!     ------------------------------------------------------------------           DIMFIX3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       DIMFIX3A.3     
!                                                                                  DIMFIX3A.4     
!     MODULE TO SET INTERNAL DIMENSIONS TIED TO ALGORITHMS,                        DIMFIX3A.5     
!     MOSTLY FOR CLOUDS.                                                           DIMFIX3A.6     
!                                                                                  DIMFIX3A.7     
      INTEGER                                                                      DIMFIX3A.8     
     &     NPD_CLOUD_COMPONENT                                                     DIMFIX3A.9     
!             NUMBER OF COMPONENTS OF CLOUDS                                       DIMFIX3A.10    
     &   , NPD_CLOUD_TYPE                                                          DIMFIX3A.11    
!             NUMBER OF PERMITTED TYPES OF CLOUDS.                                 DIMFIX3A.12    
     &   , NPD_CLOUD_REPRESENTATION                                                DIMFIX3A.13    
!             NUMBER OF PERMITTED REPRESENTATIONS OF CLOUDS.                       DIMFIX3A.14    
     &   , NPD_OVERLAP_COEFF                                                       DIMFIX3A.15    
!             NUMBER OF OVERLAP COEFFICIENTS FOR CLOUDS                            DIMFIX3A.16    
     &   , NPD_SOURCE_COEFF                                                        DIMFIX3A.17    
!             NUMBER OF COEFFICIENTS FOR TWO-STREAM SOURCES                        DIMFIX3A.18    
     &   , NPD_REGION                                                              DIMFIX3A.19    
!             NUMBER OF REGIONS IN A LAYER                                         DIMFIX3A.20    
!                                                                                  DIMFIX3A.21    
      PARAMETER(                                                                   DIMFIX3A.22    
     &     NPD_CLOUD_COMPONENT=4                                                   DIMFIX3A.23    
     &   , NPD_CLOUD_TYPE=4                                                        DIMFIX3A.24    
     &   , NPD_CLOUD_REPRESENTATION=4                                              DIMFIX3A.25    
     &   , NPD_OVERLAP_COEFF=18                                                    DIMFIX3A.26    
     &   , NPD_SOURCE_COEFF=2                                                      DIMFIX3A.27    
     &   , NPD_REGION=3                                                            DIMFIX3A.28    
     &   )                                                                         DIMFIX3A.29    
!                                                                                  DIMFIX3A.30    
!     ------------------------------------------------------------------           DIMFIX3A.31    
!     ------------------------------------------------------------------           SPCRG3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       SPCRG3A.3     
!                                                                                  SPCRG3A.4     
!     MODULE TO SET FLAGS FOR DIFFERENT PORTIONS                                   SPCRG3A.5     
!     OF THE SPECTRUM.                                                             SPCRG3A.6     
!                                                                                  SPCRG3A.7     
      INTEGER                                                                      SPCRG3A.8     
     &     IP_SOLAR                                                                SPCRG3A.9     
!             SOLAR REGION                                                         SPCRG3A.10    
     &   , IP_INFRA_RED                                                            SPCRG3A.11    
!             INFRA-RED REGION                                                     SPCRG3A.12    
!                                                                                  SPCRG3A.13    
      PARAMETER(                                                                   SPCRG3A.14    
     &     IP_SOLAR=1                                                              SPCRG3A.15    
     &   , IP_INFRA_RED=2                                                          SPCRG3A.16    
     &   )                                                                         SPCRG3A.17    
!                                                                                  SPCRG3A.18    
!     ------------------------------------------------------------------           SPCRG3A.19    
!     ------------------------------------------------------------------           PRMCH3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       PRMCH3A.3     
!                                                                                  PRMCH3A.4     
!     MODULE FOR SETTING MACHINE PRECISION.                                        PRMCH3A.5     
!                                                                                  PRMCH3A.6     
      REAL                                                                         PRMCH3A.7     
     &     TOL_MACHINE                                                             PRMCH3A.8     
!             MACHINE TOLERANCE                                                    PRMCH3A.9     
     &   , SQRT_TOL_MACHINE                                                        PRMCH3A.10    
!             SQRT OF MACHINE TOLERANCE                                            PRMCH3A.11    
!                                                                                  PRMCH3A.12    
!                                                                                  PRMCH3A.13    
!     THE PRECISION SHOULD BE ABOUT 2/2^(SIZE OF SIGNIFICAND)                      PRMCH3A.14    
!                                                                                  PRMCH3A.15    
!     THE IEEE-FORMAT USES 53 BITS FOR THE SIGNIFICAND                             PRMCH3A.16    
!     IN DOUBLE PRECISION                                                          PRMCH3A.17    
!                                                                                  PRMCH3A.18    
!     THE CRAY FORMAT USES 47 BITS IN SINGLE PRECISION.                            PRMCH3A.19    
!                                                                                  PRMCH3A.20    
      PARAMETER(                                                                   PRMCH3A.21    
     &     TOL_MACHINE=1.42E-14                                                    PRMCH3A.22    
     &   , SQRT_TOL_MACHINE=1.19E-7                                                PRMCH3A.23    
     &   )                                                                         PRMCH3A.24    
!                                                                                  PRMCH3A.25    
!     ------------------------------------------------------------------           PRMCH3A.26    
!     ------------------------------------------------------------------           PRECSN3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       PRECSN3A.3     
!                                                                                  PRECSN3A.4     
!     MODULE FOR SETTING MACHINE-DEPENDENT TOLERANCES.                             PRECSN3A.5     
!     (THE COMDECK PRMCH3A MUST ALWAYS BE INCLUDED BEFORE THIS COMDECK.)           PRECSN3A.6     
!                                                                                  PRECSN3A.7     
      REAL                                                                         PRECSN3A.8     
     &     TOL_DIV                                                                 PRECSN3A.9     
!             TOLERANCE FOR DIVISION                                               PRECSN3A.10    
     &   , TOL_TEST                                                                PRECSN3A.11    
!             TOLERANCE FOR TESTING EQUALITY                                       PRECSN3A.12    
!                                                                                  PRECSN3A.13    
      PARAMETER(                                                                   PRECSN3A.14    
     &     TOL_DIV=3.2E+01*TOL_MACHINE                                             PRECSN3A.15    
     &   , TOL_TEST=1.6E+01*TOL_MACHINE                                            PRECSN3A.16    
     &   )                                                                         PRECSN3A.17    
!                                                                                  PRECSN3A.18    
!     ------------------------------------------------------------------           PRECSN3A.19    
!     ------------------------------------------------------------------           ERROR3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       ERROR3A.3     
!                                                                                  ERROR3A.4     
!     MODULE TO SET ERROR FLAGS IN THE RADIATION CODE.                             ERROR3A.5     
!                                                                                  ERROR3A.6     
      INTEGER                                                                      ERROR3A.7     
     &     I_NORMAL                                                                ERROR3A.8     
!             ERROR FREE CONDITION                                                 ERROR3A.9     
     &   , I_ERR_FATAL                                                             ERROR3A.10    
!             FATAL ERROR: IMMEDIATE RETURN                                        ERROR3A.11    
     &   , I_ABORT_CALCULATION                                                     ERROR3A.12    
!             CALCULATION ABORTED                                                  ERROR3A.13    
     &   , I_MISSING_DATA                                                          ERROR3A.14    
!             MISSING DATA ERROR: CONDITIONAL                                      ERROR3A.15    
     &   , I_ERR_IO                                                                ERROR3A.16    
!             I/O ERROR                                                            ERROR3A.17    
     &   , I_ERR_RANGE                                                             ERROR3A.18    
!             INTERPOLATION RANGE ERROR                                            ERROR3A.19    
     &   , I_ERR_EXIST                                                             ERROR3A.20    
!             EXISTENCE ERROR                                                      ERROR3A.21    
!                                                                                  ERROR3A.22    
      PARAMETER(                                                                   ERROR3A.23    
     &     I_NORMAL=0                                                              ERROR3A.24    
     &   , I_ERR_FATAL=1                                                           ERROR3A.25    
     &   , I_ABORT_CALCULATION=2                                                   ERROR3A.26    
     &   , I_MISSING_DATA=3                                                        ERROR3A.27    
     &   , I_ERR_IO=4                                                              ERROR3A.28    
     &   , I_ERR_RANGE=5                                                           ERROR3A.29    
     &   , I_ERR_EXIST=6                                                           ERROR3A.30    
     &   )                                                                         ERROR3A.31    
!                                                                                  ERROR3A.32    
!     ------------------------------------------------------------------           ERROR3A.33    
!                                                                                  RAD_ALL.24331 
!                                                                                  RAD_ALL.24332 
!                                                                                  RAD_ALL.24333 
!     DUMMY ARGUMENTS.                                                             RAD_ALL.24334 
      INTEGER   !, INTENT(OUT)                                                     RAD_ALL.24335 
     &     IERR                                                                    RAD_ALL.24336 
!             ERROR FLAG                                                           RAD_ALL.24337 
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.24338 
     &     N_PROFILE                                                               RAD_ALL.24339 
!             NUMBER OF PROFILES                                                   RAD_ALL.24340 
     &   , I_LAYER_FIRST                                                           RAD_ALL.24341 
!             FIRST LAYER TO CONSIDER                                              RAD_ALL.24342 
     &   , I_LAYER_LAST                                                            RAD_ALL.24343 
!             LAST LAYER TO CONSIDER                                               RAD_ALL.24344 
     &   , ISOLIR                                                                  RAD_ALL.24345 
!             SPECTRAL REGION                                                      RAD_ALL.24346 
     &   , I_2STREAM                                                               RAD_ALL.24347 
!             TWO STREAM SCHEME                                                    RAD_ALL.24348 
      LOGICAL   !, INTENT(IN)                                                      RAD_ALL.24349 
     &     L_IR_SOURCE_QUAD                                                        RAD_ALL.24350 
!               USE A QUADRATIC SOURCE FUNCTION                                    RAD_ALL.24351 
!                                                                                  RAD_ALL.24352 
!     OPTICAL PROPERTIES OF LAYER:                                                 RAD_ALL.24353 
      REAL      !, INTENT(IN)                                                      RAD_ALL.24354 
     &     ASYMMETRY(NPD_PROFILE, NPD_LAYER)                                       RAD_ALL.24355 
!             ASYMMETRY FACTOR                                                     RAD_ALL.24356 
     &   , OMEGA(NPD_PROFILE, NPD_LAYER)                                           RAD_ALL.24357 
!             ALBEDO OF SINGLE SCATTERING                                          RAD_ALL.24358 
     &   , TAU(NPD_PROFILE, NPD_LAYER)                                             RAD_ALL.24359 
!             OPTICAL DEPTH                                                        RAD_ALL.24360 
!                                                                                  RAD_ALL.24361 
!     SOLAR BEAM                                                                   RAD_ALL.24362 
      REAL      !, INTENT(IN)                                                      RAD_ALL.24363 
     &     SEC_0(NPD_PROFILE)                                                      RAD_ALL.24364 
!             SECANT OF ZENITH ANGLE                                               RAD_ALL.24365 
!                                                                                  RAD_ALL.24366 
!                                                                                  RAD_ALL.24367 
!     COEFFICIENTS IN THE TWO-STREAM EQUATIONS:                                    RAD_ALL.24368 
      REAL      !, INTENT(OUT)                                                     RAD_ALL.24369 
     &     TRANS(NPD_PROFILE, NPD_LAYER)                                           RAD_ALL.24370 
!             DIFFUSE TRANSMISSION COEFFICIENT                                     RAD_ALL.24371 
     &   , REFLECT(NPD_PROFILE, NPD_LAYER)                                         RAD_ALL.24372 
!             DIFFUSE REFLECTION COEFFICIENT                                       RAD_ALL.24373 
     &   , TRANS_0(NPD_PROFILE, NPD_LAYER)                                         RAD_ALL.24374 
!             DIRECT TRANSMISSION COEFFICIENT                                      RAD_ALL.24375 
     &   , SOURCE_COEFF(NPD_PROFILE, NPD_LAYER, NPD_SOURCE_COEFF)                  RAD_ALL.24376 
!             SOURCE COEFFICIENTS IN TWO-STREAM EQUATIONS                          RAD_ALL.24377 
!                                                                                  RAD_ALL.24378 
!                                                                                  RAD_ALL.24379 
!     LOCAL VARIABLES.                                                             RAD_ALL.24380 
      INTEGER                                                                      RAD_ALL.24381 
     &     I                                                                       RAD_ALL.24382 
!             LOOP VARIABLE                                                        RAD_ALL.24383 
     &   , L                                                                       RAD_ALL.24384 
!             LOOP VARIABLE                                                        RAD_ALL.24385 
     &   , K                                                                       RAD_ALL.24386 
!             LOOP VARIABLE                                                        RAD_ALL.24387 
     &   , N_INDEX                                                                 RAD_ALL.24388 
!             NUMBER OF INDICES SATISFYING TEST                                    RAD_ALL.24389 
     &   , INDEX(NPD_PROFILE)                                                      RAD_ALL.24390 
!             INDICES OF TESTED POINTS                                             RAD_ALL.24391 
!                                                                                  RAD_ALL.24392 
!     COEFFICIENTS IN THE TWO-STREAM EQUATIONS:                                    RAD_ALL.24393 
      REAL                                                                         RAD_ALL.24394 
     &     LAMBDA(NPD_PROFILE, NPD_LAYER)                                          RAD_ALL.24395 
!             COEFFICIENTS IN TWO-STREAM EQUATIONS                                 RAD_ALL.24396 
     &   , SUM(NPD_PROFILE, NPD_LAYER)                                             RAD_ALL.24397 
!             SUM OF ALPHA_1 AND ALPHA_2                                           RAD_ALL.24398 
     &   , DIFF(NPD_PROFILE, NPD_LAYER)                                            RAD_ALL.24399 
!             DIFFERENCE OF ALPHA_1 AND ALPHA_2                                    RAD_ALL.24400 
     &   , GAMMA_UP(NPD_PROFILE, NPD_LAYER)                                        RAD_ALL.24401 
!             BASIC SOLAR COEFFICIENT FOR UPWARD RADIATION                         RAD_ALL.24402 
     &   , GAMMA_DOWN(NPD_PROFILE, NPD_LAYER)                                      RAD_ALL.24403 
!             BASIC SOLAR COEFFICIENT FOR DOWNWARD RADIATION                       RAD_ALL.24404 
!                                                                                  RAD_ALL.24405 
      REAL                                                                         RAD_ALL.24406 
     &     TARGET                                                                  RAD_ALL.24407 
!             TARGET TO SEARCH FOR                                                 RAD_ALL.24408 
!                                                                                  RAD_ALL.24409 
!                                                                                  RAD_ALL.24410 
!     SUBROUTINES CALLED:                                                          RAD_ALL.24411 
      EXTERNAL                                                                     RAD_ALL.24412 
     &     TWO_COEFF_BASIC, SOLAR_COEFFICIENT_BASIC                                RAD_ALL.24413 
     &   , TRANS_SOURCE_COEFF                                                      RAD_ALL.24414 
!                                                                                  RAD_ALL.24415 
!     CRAY DIRECTIVES FOR THE WHOLE ROUTINE:                                       RAD_ALL.24416 
!     POINTS ARE NOT REPEATED IN THE INDEXING ARRAY, SO IT IS SAFE                 RAD_ALL.24417 
!     TO VECTORIZE OVER INDIRECTLY ADDRESSED ARRAYS.                               RAD_ALL.24418 
Cfpp$ NODEPCHK R                                                                   RAD_ALL.24419 
!                                                                                  RAD_ALL.24420 
!                                                                                  RAD_ALL.24421 
!                                                                                  RAD_ALL.24422 
!     PERTURB THE SINGLE SCATTERING ALBEDO AWAY FROM 1 TO AVOID                    RAD_ALL.24423 
!     LATER DIVISION BY 0.                                                         RAD_ALL.24424 
      TARGET=1.0E+00-TOL_DIV                                                       RAD_ALL.24425 
      DO I=I_LAYER_FIRST, I_LAYER_LAST                                             RAD_ALL.24426 
!                                                                                  RAD_ALL.24427 
         N_INDEX=0                                                                 RAD_ALL.24428 
         DO L   =1,N_PROFILE                                                       RAD_ALL.24429 
           IF (OMEGA(L,I).GT.TARGET) THEN                                          RAD_ALL.24430 
             N_INDEX =N_INDEX+1                                                    RAD_ALL.24431 
             INDEX(N_INDEX)=L                                                      RAD_ALL.24432 
           END IF                                                                  RAD_ALL.24433 
         END DO                                                                    RAD_ALL.24434 
!                                                                                  RAD_ALL.24435 
         DO K=1, N_INDEX                                                           RAD_ALL.24436 
            OMEGA(INDEX(K), I)=TARGET                                              RAD_ALL.24437 
         ENDDO                                                                     RAD_ALL.24438 
      ENDDO                                                                        RAD_ALL.24439 
!                                                                                  RAD_ALL.24440 
!     CALCULATE THE BASIC TWO-STREAM COEFFICIENTS.                                 RAD_ALL.24441 
      CALL TWO_COEFF_BASIC(IERR                                                    RAD_ALL.24442 
     &   , N_PROFILE, I_LAYER_FIRST, I_LAYER_LAST                                  RAD_ALL.24443 
     &   , I_2STREAM                                                               RAD_ALL.24444 
     &   , ASYMMETRY, OMEGA                                                        RAD_ALL.24445 
     &   , SUM, DIFF                                                               RAD_ALL.24446 
     &   , NPD_PROFILE, NPD_LAYER                                                  RAD_ALL.24447 
     &   )                                                                         RAD_ALL.24448 
      IF (IERR.NE.I_NORMAL) THEN                                                   RAD_ALL.24449 
         RETURN                                                                    RAD_ALL.24450 
      ENDIF                                                                        RAD_ALL.24451 
!                                                                                  RAD_ALL.24452 
!     LAMBDA IS NOW CALCULATED.                                                    RAD_ALL.24453 
      DO I=I_LAYER_FIRST, I_LAYER_LAST                                             RAD_ALL.24454 
         DO L=1, N_PROFILE                                                         RAD_ALL.24455 
            LAMBDA(L, I)=SQRT(SUM(L, I)*DIFF(L, I))                                RAD_ALL.24456 
         ENDDO                                                                     RAD_ALL.24457 
      ENDDO                                                                        RAD_ALL.24458 
!                                                                                  RAD_ALL.24459 
!                                                                                  RAD_ALL.24460 
!     CALCULATE THE BASIC COEFFICIENTS FOR THE SOLAR SOURCE TERMS.                 RAD_ALL.24461 
      IF (ISOLIR.EQ.IP_SOLAR) THEN                                                 RAD_ALL.24462 
!        LAMBDA MAY BE PERTURBED BY THIS ROUTINE TO AVOID                          RAD_ALL.24463 
!        ILL-CONDITIONING FOR THE SINGULAR ZENITH ANGLE.                           RAD_ALL.24464 
         CALL SOLAR_COEFFICIENT_BASIC(IERR                                         RAD_ALL.24465 
     &      , N_PROFILE, I_LAYER_FIRST, I_LAYER_LAST                               RAD_ALL.24466 
     &      , OMEGA, ASYMMETRY, SEC_0                                              RAD_ALL.24467 
     &      , I_2STREAM                                                            RAD_ALL.24468 
     &      , SUM, DIFF, LAMBDA                                                    RAD_ALL.24469 
     &      , GAMMA_UP, GAMMA_DOWN                                                 RAD_ALL.24470 
     &      , NPD_PROFILE, NPD_LAYER                                               RAD_ALL.24471 
     &      )                                                                      RAD_ALL.24472 
         IF (IERR.NE.I_NORMAL) RETURN                                              RAD_ALL.24473 
      ENDIF                                                                        RAD_ALL.24474 
!                                                                                  RAD_ALL.24475 
!                                                                                  RAD_ALL.24476 
!     DETERMINE THE TRANSMISSION AND REFLECTION COEFFICIENTS.                      RAD_ALL.24477 
      CALL TRANS_SOURCE_COEFF(N_PROFILE, I_LAYER_FIRST, I_LAYER_LAST               RAD_ALL.24478 
     &   , ISOLIR, L_IR_SOURCE_QUAD                                                RAD_ALL.24479 
     &   , TAU, SUM, DIFF, LAMBDA, SEC_0                                           RAD_ALL.24480 
     &   , GAMMA_UP, GAMMA_DOWN                                                    RAD_ALL.24481 
     &   , TRANS, REFLECT, TRANS_0, SOURCE_COEFF                                   RAD_ALL.24482 
     &   , NPD_PROFILE, NPD_LAYER                                                  RAD_ALL.24483 
     &   )                                                                         RAD_ALL.24484 
!                                                                                  RAD_ALL.24485 
!                                                                                  RAD_ALL.24486 
!                                                                                  RAD_ALL.24487 
      RETURN                                                                       RAD_ALL.24488 
      END  
